Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# GraphicsWindow Class Reference

A window, fullscreen or on a desktop, into which a graphics device sends its output for interactive display. More...

Inheritance diagram for GraphicsWindow:

List of all members.

## Public Member Functions
| addPythonEventHandler (PyObject handler, PyObject name)
| Adds a python event handler to be called when a window event occurs.
| clearRejectedProperties ()
| Empties the set of failed properties that will be returned by get_rejected_properties().
| closeIme ()
| Forces the ime window to close if any.
| disablePointerEvents (int device)
| Turn off the generation of pointer events.
| disablePointerMode (int device)
| See GraphicsWindowInputDevice.disable_pointer_mode.
| enablePointerEvents (int device)
| Turn on the generation of pointer events.
| enablePointerMode (int device, double speed)
| See GraphicsWindowInputDevice.enable_pointer_mode.
string | getCloseRequestEvent ()
| Returns the name of the event set via set_close_request_event().
string | getInputDeviceName (int device)
| Returns the name of the nth input device.
list | getInputDeviceNames ()
int | getNumInputDevices ()
| Returns the number of separate input devices associated with the window.
MouseData | getPointer (int device)
| Returns the MouseData associated with the nth input device's pointer.
WindowProperties const | getProperties ()
| Returns the current properties of the window.
WindowProperties | getRejectedProperties ()
| Returns the set of properties that have recently been requested, but could not be applied to the window for some reason.
WindowProperties const | getRequestedProperties ()
| Returns the properties of the window that are currently requested.
bool | getUnexposedDraw ()
| See set_unexposed_draw().
string | getWindowEvent ()
| Returns the name of the event that is generated when this window is modified externally, e.g.
WindowHandle | getWindowHandle ()
| Returns the WindowHandle corresponding to this window on the desktop.
bool | hasKeyboard (int device)
| Returns true if the nth input device has a keyboard, false otherwise.
bool | hasPointer (int device)
| Returns true if the nth input device has a screen-space pointer (for instance, a mouse), false otherwise.
bool | isClosed ()
| Returns true if the window has not yet been opened, or has been fully closed, false if it is open.
bool | isFullscreen ()
| Returns true if the window has been opened as a fullscreen window, false otherwise.
bool | movePointer (int device, int x, int y)
| Forces the pointer to the indicated position within the window, if possible.
| removePythonEventHandler (PyObject name)
| Removes the specified python event handler.
| requestProperties (WindowProperties const requested_properties)
| Requests a property change on the window.
| setCloseRequestEvent (string close_request_event)
| Sets the event that is triggered when the user requests to close the window, e.g.
| setUnexposedDraw (bool unexposed_draw)
| If this flag is false, the window is redrawn only after it has received a recent "unexpose" or "draw" event from the underlying windowing systme.
| setWindowEvent (string window_event)
| Changes the name of the event that is generated when this window is modified externally, e.g.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A window, fullscreen or on a desktop, into which a graphics device sends its output for interactive display.

## Member Function Documentation

addPythonEventHandler | ( | PyObject | handler,
|  | PyObject | name
| ) |  |

Adds a python event handler to be called when a window event occurs.

clearRejectedProperties | ( |  | ) |

Empties the set of failed properties that will be returned by get_rejected_properties().

closeIme | ( |  | ) |

Forces the ime window to close if any.

disablePointerEvents | ( | int | device | ) |

Turn off the generation of pointer events.

disablePointerMode | ( | int | device | ) |

See GraphicsWindowInputDevice.disable_pointer_mode.

enablePointerEvents | ( | int | device | ) |

Turn on the generation of pointer events.

enablePointerMode | ( | int | device,
|  | double | speed
| ) |  |

See GraphicsWindowInputDevice.enable_pointer_mode.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from GraphicsOutput.

Reimplemented in CallbackGraphicsWindow.

string getCloseRequestEvent | ( |  | ) |

Returns the name of the event set via set_close_request_event().

If this string is nonempty, then when the user requests to close window, this event will be generated instead. See set_close_request_event().

string getInputDeviceName | ( | int | device | ) |

Returns the name of the nth input device.

list getInputDeviceNames | ( |  | ) |

int getNumInputDevices | ( |  | ) |

Returns the number of separate input devices associated with the window.

Typically, a window will have exactly one input device: the keyboard/mouse pair. However, some windows may have no input devices, and others may add additional devices, for instance for a joystick.

MouseData getPointer | ( | int | device | ) |

Returns the MouseData associated with the nth input device's pointer.

WindowProperties const getProperties | ( |  | ) |

Returns the current properties of the window.

WindowProperties getRejectedProperties | ( |  | ) |

Returns the set of properties that have recently been requested, but could not be applied to the window for some reason.

This set of properties will remain unchanged until they are changed by a new failed request, or clear_rejected_properties() is called.

WindowProperties const getRequestedProperties | ( |  | ) |

Returns the properties of the window that are currently requested.

These properties will be applied to the window (if valid) at the next execution of process_events().

bool getUnexposedDraw | ( |  | ) |

See set_unexposed_draw().

string getWindowEvent | ( |  | ) |

Returns the name of the event that is generated when this window is modified externally, e.g.

to be resized or closed by the user. See set_window_event().

WindowHandle getWindowHandle | ( |  | ) |

Returns the WindowHandle corresponding to this window on the desktop.

This is mainly useful for communicating with external libraries. Use window_handle->get_os_handle()->get_handle(), or window_handle->get_string_handle(), to get the actual OS-specific window handle object, whatever type that might be.

bool hasKeyboard | ( | int | device | ) |

Returns true if the nth input device has a keyboard, false otherwise.

bool hasPointer | ( | int | device | ) |

Returns true if the nth input device has a screen-space pointer (for instance, a mouse), false otherwise.

bool isClosed | ( |  | ) |

Returns true if the window has not yet been opened, or has been fully closed, false if it is open.

The window is not opened immediately after GraphicsEngine.make_window() is called; nor is it closed immediately after GraphicsEngine.remove_window() is called. Either operation may take a frame or two.

bool isFullscreen | ( |  | ) |

Returns true if the window has been opened as a fullscreen window, false otherwise.

bool movePointer | ( | int | device,
|  | int | x,
|  | int | y
| ) |  |

Forces the pointer to the indicated position within the window, if possible.

Returns true if successful, false on failure. This may fail if the mouse is not currently within the window, or if the API doesn't support this operation.

removePythonEventHandler | ( | PyObject | name | ) |

Removes the specified python event handler.

requestProperties | ( | WindowProperties const | requested_properties | ) |

Requests a property change on the window.

For example, use this method to request a window change size or minimize or something.

The change is not made immediately; rather, the request is saved and will be applied the next time the window task is run (probably at the next frame).

setCloseRequestEvent | ( | string | close_request_event | ) |

Sets the event that is triggered when the user requests to close the window, e.g.

via alt-F4, or clicking on the close box.

The default for each window is for this event to be the empty string, which means the window-close request is handled immediately by Panda (and the window will be closed without the app getting a chance to intervene). If you set this to a nonempty string, then the window is not closed, but instead the event is thrown. It is then up to the app to respond appropriately, for instance by presenting an "are you sure?" dialog box, and eventually calling close_window() when the user is sure.

It is considered poor form to set this string and then not handle the event. This can frustrate the user by making it difficult for him to cleanly shut down the application (and may force the user to hard-kill the app, or reboot the machine).

setUnexposedDraw | ( | bool | unexposed_draw | ) |

If this flag is false, the window is redrawn only after it has received a recent "unexpose" or "draw" event from the underlying windowing systme.

If this flag is true, the window is redrawn every frame regardless. Setting this false may prevent the window from redrawing unnecessarily when it is hidden, and may play nicer with other windows on the desktop, but may adversely affect frame rate even when the window is fully visible; setting it true will ensure that the window contents are always current.

setWindowEvent | ( | string | window_event | ) |

Changes the name of the event that is generated when this window is modified externally, e.g.

to be resized or closed by the user.

By default, all windows have the same window event unless they are explicitly changed. When the event is generated, it includes one parameter: the window itself.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties